## rtl8821ce 5.2.5.2.1.30816.20190425

=== Makefile ===
# SPDX-License-Identifier: GPL-2.0
obj-m := rtl8821ce.o

rtl8821ce-objs += core/rtw_cmd.o \
		core/rtw_security.o \
		core/rtw_debug.o \
		core/rtw_io.o \
		core/rtw_ioctl_set.o \
		core/rtw_ieee80211.o \
		core/rtw_mlme.o \
		core/rtw_mlme_ext.o \
		core/rtw_mi.o \
		core/rtw_wlan_util.o \
		core/rtw_vht.o \
		core/rtw_pwrctrl.o \
		core/rtw_rf.o \
		core/rtw_recv.o \
		core/rtw_sta_mgt.o \
		core/rtw_ap.o \
		core/rtw_xmit.o	\
		core/rtw_p2p.o \
		core/rtw_br_ext.o \
		core/rtw_sreset.o \
		core/rtw_btcoex_wifionly.o \
		core/rtw_btcoex.o \
		core/rtw_odm.o \
		core/rtw_mp.o \
		core/efuse/rtw_efuse.o \
		os_dep/osdep_service.o \
		os_dep/linux/os_intfs.o \
		os_dep/linux/pci_intf.o \
		os_dep/linux/ioctl_linux.o \
		os_dep/linux/xmit_linux.o \
		os_dep/linux/mlme_linux.o \
		os_dep/linux/recv_linux.o \
		os_dep/linux/rtw_android.o \
		os_dep/linux/ioctl_mp.o \
		hal/hal_intf.o \
		hal/hal_com.o \
		hal/hal_com_phycfg.o \
		hal/hal_dm.o \
		hal/hal_btcoex_wifionly.o \
		hal/hal_btcoex.o \
		hal/hal_mp.o \
		hal/halmac/halmac_api.o \
		hal/halmac/halmac_88xx/halmac_api_88xx.o \
		hal/halmac/halmac_88xx/halmac_func_88xx.o \
		hal/halmac/halmac_88xx/halmac_api_88xx_pcie.o \
		hal/halmac/halmac_88xx/halmac_8821c/halmac_8821c_pwr_seq.o \
		hal/halmac/halmac_88xx/halmac_8821c/halmac_api_8821c.o \
		hal/halmac/halmac_88xx/halmac_8821c/halmac_func_8821c.o \
		hal/halmac/halmac_88xx/halmac_8821c/halmac_api_8821c_pcie.o \
		hal/halmac/halmac_88xx/halmac_8821c/halmac_8821c_phy.o \
		hal/hal_halmac.o \
		hal/rtl8821c/rtl8821c_halinit.o \
		hal/rtl8821c/rtl8821c_mac.o \
		hal/rtl8821c/rtl8821c_cmd.o \
		hal/rtl8821c/rtl8821c_phy.o \
		hal/rtl8821c/rtl8821c_dm.o \
		hal/rtl8821c/rtl8821c_ops.o \
		hal/rtl8821c/hal8821c_fw.o \
		hal/rtl8821c/pci/rtl8821ce_halinit.o \
		hal/rtl8821c/pci/rtl8821ce_halmac.o \
		hal/rtl8821c/pci/rtl8821ce_io.o \
		hal/rtl8821c/pci/rtl8821ce_xmit.o \
		hal/rtl8821c/pci/rtl8821ce_recv.o \
		hal/rtl8821c/pci/rtl8821ce_ops.o \
		hal/efuse/rtl8821c/HalEfuseMask8821C_PCIE.o \
		hal/phydm/phydm_debug.o \
		hal/phydm/phydm_interface.o \
		hal/phydm/phydm_hwconfig.o \
		hal/phydm/phydm.o \
		hal/phydm/halphyrf_ce.o \
		hal/phydm/phydm_dig.o \
		hal/phydm/phydm_pathdiv.o \
		hal/phydm/phydm_rainfo.o \
		hal/phydm/phydm_dynamicbbpowersaving.o \
		hal/phydm/phydm_powertracking_ce.o \
		hal/phydm/phydm_adaptivity.o \
		hal/phydm/phydm_cfotracking.o \
		hal/phydm/phydm_acs.o \
		hal/phydm/phydm_dfs.o \
		hal/phydm/phydm_adc_sampling.o \
		hal/phydm/phydm_kfree.o \
		hal/phydm/phydm_ccx.o \
		hal/phydm/phydm_psd.o \
		hal/btc/halbtc8821cwifionly.o \
		hal/btc/halbtc8821c1ant.o \
		hal/btc/halbtc8821c2ant.o \
		hal/phydm/rtl8821c/halhwimg8821c_bb.o \
		hal/phydm/rtl8821c/halhwimg8821c_mac.o \
		hal/phydm/rtl8821c/halhwimg8821c_rf.o \
		hal/phydm/rtl8821c/phydm_hal_api8821c.o \
		hal/phydm/rtl8821c/phydm_regconfig8821c.o \
		hal/phydm/rtl8821c/halphyrf_8821c.o \
		hal/phydm/rtl8821c/phydm_iqk_8821c.o

ccflags-y += -I$(src)/include \
	     -I$(src)/hal/btc \
	     -I$(src)/hal/phydm \
	     -I$(src)/platform

=== debian/changelog ===
rtl8821ce (5.2.5.2.1.30816.20190425-0ubuntu1) eoan; urgency=medium

  * Initial release (LP: #1837876)

 -- Anthony Wong <anthony.wong@canonical.com>  Mon, 24 Jun 2019 19:39:31 +0800

=== debian/control ===
Source: rtl8821ce
Section: kernel
Priority: optional
Maintainer: Canonical HWE Team <canonical-hwe@lists.canonical.com>
Build-Depends: debhelper (>= 11), dkms, dh-modaliases
Standards-Version: 4.3.0
Vcs-Git: https://git.launchpad.net/~canonical-hwe-team/+git/rtl8821ce
Vcs-Browser: https://code.launchpad.net/~canonical-hwe-team/+git/rtl8821ce

Package: rtl8821ce-dkms
Architecture: all
Depends: ${misc:Depends}, dkms
XB-Modaliases: ${modaliases}
Description: DKMS source for the Realtek 8821C PCIe WiFi driver
 This package provides the DKMS source code for the rtl8821ce kernel module.
 Kernel source or headers are required to compile these modules.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk

%:
	dh $@ --with dkms,modaliases

override_dh_install:
	dh_install -Xdebian * usr/src/rtl8821ce-$(DEB_VERSION_UPSTREAM)/

override_dh_dkms:
	dh_dkms -V $(DEB_VERSION_UPSTREAM)

override_dh_auto_configure:
override_dh_auto_build:
override_dh_auto_test:
override_dh_auto_install:
override_dh_auto_clean:

## rtl8821ce 5.5.2

=== debian/changelog ===
rtl8821ce (5.5.2-1) unstable; urgency=medium

  * update

 -- liuxin <liuxin@uniontech.com>  Wed, 20 Jan 2021 11:09:33 +0800

rtl8821ce (5.5.2) unstable; urgency=medium

  * Initial release

 -- liuxin <liuxin@uniontech.com>  Tue, 12 Jan 2021 14:49:45 +0800

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

include /usr/share/dpkg/default.mk

export DH_VERBOSE = 1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

VERSION ?= $(shell dpkg-parsechangelog | sed -rne 's/^Version: ([0-9.]+).*$$/\1/p')

%:
	dh $@ --with dkms

override_dh_auto_install:
	dh_install -prtl8821ce-dkms -X.o -X.ko core/       usr/src/rtl8821ce-$(VERSION)
	dh_install -prtl8821ce-dkms -X.o -X.ko hal/        usr/src/rtl8821ce-$(VERSION)
	dh_install -prtl8821ce-dkms -X.o -X.ko os_dep/     usr/src/rtl8821ce-$(VERSION)
	dh_install -prtl8821ce-dkms -X.o -X.ko platform/   usr/src/rtl8821ce-$(VERSION)
	dh_install -prtl8821ce-dkms -X.o -X.ko include/    usr/src/rtl8821ce-$(VERSION)
	dh_install -prtl8821ce-dkms Makefile               usr/src/rtl8821ce-$(VERSION)
	dh_install -prtl8821ce-dkms rtl8821c.mk			   usr/src/rtl8821ce-$(VERSION)
	dh_install -prtl8821ce-dkms dkms.conf              usr/src/rtl8821ce-$(VERSION)
	dh_install -prtl8821ce-dkms halmac.mk              usr/src/rtl8821ce-$(VERSION)

override_dh_dkms:
	dh_dkms -V

override_dh_auto_build:
	:

## rtl8821ce 5.5.2.1

=== Makefile ===
EXTRA_CFLAGS += $(USER_EXTRA_CFLAGS)
EXTRA_CFLAGS += -O1
#EXTRA_CFLAGS += -O3
#EXTRA_CFLAGS += -Wall
#EXTRA_CFLAGS += -Wextra
#EXTRA_CFLAGS += -Werror
#EXTRA_CFLAGS += -pedantic
#EXTRA_CFLAGS += -Wshadow -Wpointer-arith -Wcast-qual -Wstrict-prototypes -Wmissing-prototypes

EXTRA_CFLAGS += -Wno-unused-variable
EXTRA_CFLAGS += -Wno-unused-value
EXTRA_CFLAGS += -Wno-unused-label
EXTRA_CFLAGS += -Wno-unused-parameter
EXTRA_CFLAGS += -Wno-unused-function
EXTRA_CFLAGS += -Wno-unused
#EXTRA_CFLAGS += -Wno-uninitialized

GCC_VER_49 := $(shell echo `$(CC) -dumpversion | cut -f1-2 -d.` \>= 4.9 | bc )
ifeq ($(GCC_VER_49),1)
EXTRA_CFLAGS += -Wno-date-time	# Fix compile error && warning on gcc 4.9 and later
endif

EXTRA_CFLAGS += -I$(src)/include

EXTRA_LDFLAGS += --strip-debug

CONFIG_AUTOCFG_CP = n

########################## WIFI IC ############################
CONFIG_MULTIDRV = n
CONFIG_RTL8188E = n
CONFIG_RTL8812A = n
CONFIG_RTL8821A = n
CONFIG_RTL8192E = n
CONFIG_RTL8723B = n
CONFIG_RTL8814A = n
CONFIG_RTL8723C = n
CONFIG_RTL8188F = n
CONFIG_RTL8188GTV = n
CONFIG_RTL8822B = n
CONFIG_RTL8723D = n
CONFIG_RTL8821C = y
CONFIG_RTL8710B = n
CONFIG_RTL8192F = n
######################### Interface ###########################
CONFIG_USB_HCI = n
CONFIG_PCI_HCI = y
CONFIG_SDIO_HCI = n
CONFIG_GSPI_HCI = n
########################## Features ###########################
CONFIG_MP_INCLUDED = y
CONFIG_POWER_SAVING = y
CONFIG_USB_AUTOSUSPEND = n
CONFIG_HW_PWRP_DETECTION = n
CONFIG_WIFI_TEST = n
CONFIG_BT_COEXIST = y
CONFIG_INTEL_WIDI = n
CONFIG_WAPI_SUPPORT = n
CONFIG_EFUSE_CONFIG_FILE = y
CONFIG_EXT_CLK = n
CONFIG_TRAFFIC_PROTECT = n
CONFIG_LOAD_PHY_PARA_FROM_FILE = y
CONFIG_TXPWR_BY_RATE_EN = auto
CONFIG_TXPWR_LIMIT_EN = auto
CONFIG_RTW_CHPLAN = 0xFF
CONFIG_RTW_ADAPTIVITY_EN = disable
CONFIG_RTW_ADAPTIVITY_MODE = normal
CONFIG_SIGNAL_SCALE_MAPPING = n
CONFIG_80211W = n
CONFIG_REDUCE_TX_CPU_LOADING = n
CONFIG_BR_EXT = y
CONFIG_TDLS = n
CONFIG_WIFI_MONITOR = n
CONFIG_MCC_MODE = n
CONFIG_APPEND_VENDOR_IE_ENABLE = n
CONFIG_RTW_NAPI = y
CONFIG_RTW_GRO = y
CONFIG_RTW_NETIF_SG = y
CONFIG_TX_CSUM_OFFLOAD = n
CONFIG_RTW_IPCAM_APPLICATION = n
CONFIG_RTW_REPEATER_SON = n
CONFIG_RTW_WIFI_HAL = n
CONFIG_ICMP_VOQ = n
########################## Debug ###########################
CONFIG_RTW_DEBUG = y
# default log level is _DRV_INFO_ = 4,
# please refer to "How_to_set_driver_debug_log_level.doc" to set the available level.
CONFIG_RTW_LOG_LEVEL = 4
######################## Wake On Lan ##########################
CONFIG_WOWLAN = n
#bit2: deauth, bit1: unicast, bit0: magic pkt.
CONFIG_WAKEUP_TYPE = 0x7
CONFIG_GPIO_WAKEUP = n
CONFIG_WAKEUP_GPIO_IDX = default
CONFIG_HIGH_ACTIVE_DEV2HST = n
######### only for USB #########
CONFIG_ONE_PIN_GPIO = n
CONFIG_HIGH_ACTIVE_HST2DEV = n
CONFIG_PNO_SUPPORT = n
CONFIG_PNO_SET_DEBUG = n
CONFIG_AP_WOWLAN = n
######### Notify SDIO Host Keep Power During Syspend ##########
CONFIG_RTW_SDIO_PM_KEEP_POWER = y
###################### MP HW TX MODE FOR VHT #######################
CONFIG_MP_VHT_HW_TX_MODE = n
###################### Platform Related #######################
CONFIG_PLATFORM_I386_PC = y
CONFIG_PLATFORM_ANDROID_X86 = n
CONFIG_PLATFORM_ANDROID_INTEL_X86 = n
CONFIG_PLATFORM_JB_X86 = n
CONFIG_PLATFORM_ARM_S3C2K4 = n
CONFIG_PLATFORM_ARM_PXA2XX = n
CONFIG_PLATFORM_ARM_S3C6K4 = n
CONFIG_PLATFORM_MIPS_RMI = n
CONFIG_PLATFORM_RTD2880B = n
CONFIG_PLATFORM_MIPS_AR9132 = n
CONFIG_PLATFORM_RTK_DMP = n
CONFIG_PLATFORM_MIPS_PLM = n
CONFIG_PLATFORM_MSTAR389 = n
CONFIG_PLATFORM_MT53XX = n
CONFIG_PLATFORM_ARM_MX51_241H = n
CONFIG_PLATFORM_FS_MX61 = n
CONFIG_PLATFORM_ACTIONS_ATJ227X = n
CONFIG_PLATFORM_TEGRA3_CARDHU = n
CONFIG_PLATFORM_TEGRA4_DALMORE = n
CONFIG_PLATFORM_ARM_TCC8900 = n
CONFIG_PLATFORM_ARM_TCC8920 = n
CONFIG_PLATFORM_ARM_TCC8920_JB42 = n
CONFIG_PLATFORM_ARM_TCC8930_JB42 = n
CONFIG_PLATFORM_ARM_RK2818 = n
CONFIG_PLATFORM_ARM_RK3066 = n
CONFIG_PLATFORM_ARM_RK3188 = n
CONFIG_PLATFORM_ARM_URBETTER = n
CONFIG_PLATFORM_ARM_TI_PANDA = n
CONFIG_PLATFORM_MIPS_JZ4760 = n
CONFIG_PLATFORM_DMP_PHILIPS = n
CONFIG_PLATFORM_MSTAR_TITANIA12 = n
CONFIG_PLATFORM_MSTAR = n
CONFIG_PLATFORM_SZEBOOK = n
CONFIG_PLATFORM_ARM_SUNxI = n
CONFIG_PLATFORM_ARM_SUN6I = n
CONFIG_PLATFORM_ARM_SUN7I = n
CONFIG_PLATFORM_ARM_SUN8I_W3P1 = n
CONFIG_PLATFORM_ARM_SUN8I_W5P1 = n
CONFIG_PLATFORM_ACTIONS_ATM702X = n
CONFIG_PLATFORM_ACTIONS_ATV5201 = n
CONFIG_PLATFORM_ACTIONS_ATM705X = n
CONFIG_PLATFORM_ARM_SUN50IW1P1 = n
CONFIG_PLATFORM_ARM_RTD299X = n
CONFIG_PLATFORM_ARM_LGE = n
CONFIG_PLATFORM_ARM_SPREADTRUM_6820 = n
CONFIG_PLATFORM_ARM_SPREADTRUM_8810 = n
CONFIG_PLATFORM_ARM_WMT = n
CONFIG_PLATFORM_TI_DM365 = n
CONFIG_PLATFORM_MOZART = n
CONFIG_PLATFORM_RTK119X = n
CONFIG_PLATFORM_RTK119X_AM = n
CONFIG_PLATFORM_RTK129X = n
CONFIG_PLATFORM_RTK390X = n
CONFIG_PLATFORM_NOVATEK_NT72668 = n
CONFIG_PLATFORM_HISILICON = n
CONFIG_PLATFORM_HISILICON_HI3798 = n
CONFIG_PLATFORM_NV_TK1 = n
CONFIG_PLATFORM_NV_TK1_UBUNTU = n
CONFIG_PLATFORM_RTL8197D = n
CONFIG_PLATFORM_AML_S905 = n
CONFIG_PLATFORM_ZTE_ZX296716 = n
########### CUSTOMER ################################
CONFIG_CUSTOMER_HUAWEI_GENERAL = n

CONFIG_DRVEXT_MODULE = n

export TopDIR ?= $(shell pwd)

########### COMMON  #################################
ifeq ($(CONFIG_GSPI_HCI), y)
HCI_NAME = gspi
endif

ifeq ($(CONFIG_SDIO_HCI), y)
HCI_NAME = sdio
endif

ifeq ($(CONFIG_USB_HCI), y)
HCI_NAME = usb
endif

ifeq ($(CONFIG_PCI_HCI), y)
HCI_NAME = pci
endif


_OS_INTFS_FILES :=	os_dep/osdep_service.o \
			os_dep/linux/os_intfs.o \
			os_dep/linux/$(HCI_NAME)_intf.o \
			os_dep/linux/$(HCI_NAME)_ops_linux.o \
			os_dep/linux/ioctl_linux.o \
			os_dep/linux/xmit_linux.o \
			os_dep/linux/mlme_linux.o \
			os_dep/linux/recv_linux.o \
			os_dep/linux/ioctl_cfg80211.o \
			os_dep/linux/rtw_cfgvendor.o \
			os_dep/linux/wifi_regd.o \
			os_dep/linux/rtw_android.o \
			os_dep/linux/rtw_proc.o \
			os_dep/linux/rtw_rhashtable.o

ifeq ($(CONFIG_MP_INCLUDED), y)
_OS_INTFS_FILES += os_dep/linux/ioctl_mp.o
endif

ifeq ($(CONFIG_SDIO_HCI), y)
_OS_INTFS_FILES += os_dep/linux/custom_gpio_linux.o
_OS_INTFS_FILES += os_dep/linux/$(HCI_NAME)_ops_linux.o
endif

ifeq ($(CONFIG_GSPI_HCI), y)
_OS_INTFS_FILES += os_dep/linux/custom_gpio_linux.o
_OS_INTFS_FILES += os_dep/linux/$(HCI_NAME)_ops_linux.o
endif


_HAL_INTFS_FILES :=	hal/hal_intf.o \
			hal/hal_com.o \
			hal/hal_com_phycfg.o \
			hal/hal_phy.o \
			hal/hal_dm.o \
			hal/hal_dm_acs.o \
			hal/hal_btcoex_wifionly.o \
			hal/hal_btcoex.o \
			hal/hal_mp.o \
			hal/hal_mcc.o \
			hal/hal_hci/hal_$(HCI_NAME).o \
			hal/led/hal_led.o \
			hal/led/hal_$(HCI_NAME)_led.o


EXTRA_CFLAGS += -I$(src)/platform
_PLATFORM_FILES := platform/platform_ops.o

EXTRA_CFLAGS += -I$(src)/hal/btc

########### HAL_RTL8188E #################################
ifeq ($(CONFIG_RTL8188E), y)

RTL871X = rtl8188e
ifeq ($(CONFIG_SDIO_HCI), y)
MODULE_NAME = 8189es
endif

ifeq ($(CONFIG_GSPI_HCI), y)
MODULE_NAME = 8189es
endif

ifeq ($(CONFIG_USB_HCI), y)
MODULE_NAME = 8188eu
endif

ifeq ($(CONFIG_PCI_HCI), y)
MODULE_NAME = 8188ee
endif
EXTRA_CFLAGS += -DCONFIG_RTL8188E

_HAL_INTFS_FILES +=	hal/HalPwrSeqCmd.o \
					hal/$(RTL871X)/Hal8188EPwrSeq.o\
 					hal/$(RTL871X)/$(RTL871X)_xmit.o\
					hal/$(RTL871X)/$(RTL871X)_sreset.o

_HAL_INTFS_FILES +=	hal/$(RTL871X)/$(RTL871X)_hal_init.o \
			hal/$(RTL871X)/$(RTL871X)_phycfg.o \
			hal/$(RTL871X)/$(RTL871X)_rf6052.o \
			hal/$(RTL871X)/$(RTL871X)_dm.o \
			hal/$(RTL871X)/$(RTL871X)_rxdesc.o \
			hal/$(RTL871X)/$(RTL871X)_cmd.o \
			hal/$(RTL871X)/hal8188e_s_fw.o \
			hal/$(RTL871X)/hal8188e_t_fw.o \
			hal/$(RTL871X)/$(HCI_NAME)/$(HCI_NAME)_halinit.o \
			hal/$(RTL871X)/$(HCI_NAME)/rtl$(MODULE_NAME)_led.o \
			hal/$(RTL871X)/$(HCI_NAME)/rtl$(MODULE_NAME)_xmit.o \
			hal/$(RTL871X)/$(HCI_NAME)/rtl$(MODULE_NAME)_recv.o

ifeq ($(CONFIG_SDIO_HCI), y)
_HAL_INTFS_FILES += hal/$(RTL871X)/$(HCI_NAME)/$(HCI_NAME)_ops.o
else
ifeq ($(CONFIG_GSPI_HCI), y)
_HAL_INTFS_FILES += hal/$(RTL871X)/$(HCI_NAME)/$(HCI_NAME)_ops.o
else
_HAL_INTFS_FILES += hal/$(RTL871X)/$(HCI_NAME)/$(HCI_NAME)_ops_linux.o
endif
endif

ifeq ($(CONFIG_USB_HCI), y)
_HAL_INTFS_FILES +=hal/efuse/$(RTL871X)/HalEfuseMask8188E_USB.o
endif
ifeq ($(CONFIG_PCI_HCI), y)
_HAL_INTFS_FILES +=hal/efuse/$(RTL871X)/HalEfuseMask8188E_PCIE.o
endif
ifeq ($(CONFIG_SDIO_HCI), y)
_HAL_INTFS_FILES +=hal/efuse/$(RTL871X)/HalEfuseMask8188E_SDIO.o
endif

endif

########### HAL_RTL8192E #################################
ifeq ($(CONFIG_RTL8192E), y)

RTL871X = rtl8192e
ifeq ($(CONFIG_SDIO_HCI), y)
MODULE_NAME = 8192es
endif

ifeq ($(CONFIG_USB_HCI), y)
MODULE_NAME = 8192eu
endif

ifeq ($(CONFIG_PCI_HCI), y)
MODULE_NAME = 8192ee
endif
EXTRA_CFLAGS += -DCONFIG_RTL8192E
_HAL_INTFS_FILES += hal/HalPwrSeqCmd.o \
					hal/$(RTL871X)/Hal8192EPwrSeq.o\
					hal/$(RTL871X)/$(RTL871X)_xmit.o\
					hal/$(RTL871X)/$(RTL871X)_sreset.o

_HAL_INTFS_FILES +=	hal/$(RTL871X)/$(RTL871X)_hal_init.o \
			hal/$(RTL871X)/$(RTL871X)_phycfg.o \
			hal/$(RTL871X)/$(RTL871X)_rf6052.o \
			hal/$(RTL871X)/$(RTL871X)_dm.o \
			hal/$(RTL871X)/$(RTL871X)_rxdesc.o \
			hal/$(RTL871X)/$(RTL871X)_cmd.o \
			hal/$(RTL871X)/hal8192e_fw.o \
			hal/$(RTL871X)/$(HCI_NAME)/$(HCI_NAME)_halinit.o \
			hal/$(RTL871X)/$(HCI_NAME)/rtl$(MODULE_NAME)_led.o \
			hal/$(RTL871X)/$(HCI_NAME)/rtl$(MODULE_NAME)_xmit.o \
			hal/$(RTL871X)/$(HCI_NAME)/rtl$(MODULE_NAME)_recv.o

ifeq ($(CONFIG_SDIO_HCI), y)
_HAL_INTFS_FILES += hal/$(RTL871X)/$(HCI_NAME)/$(HCI_NAME)_ops.o
else
ifeq ($(CONFIG_GSPI_HCI), y)
_HAL_INTFS_FILES += hal/$(RTL871X)/$(HCI_NAME)/$(HCI_NAME)_ops.o
else
_HAL_INTFS_FILES += hal/$(RTL871X)/$(HCI_NAME)/$(HCI_NAME)_ops_linux.o
endif
endif

ifeq ($(CONFIG_USB_HCI), y)
_HAL_INTFS_FILES +=hal/efuse/$(RTL871X)/HalEfuseMask8192E_USB.o
endif
ifeq ($(CONFIG_PCI_HCI), y)
_HAL_INTFS_FILES +=hal/efuse/$(RTL871X)/HalEfuseMask8192E_PCIE.o
endif
ifeq ($(CONFIG_SDIO_HCI), y)
_HAL_INTFS_FILES +=hal/efuse/$(RTL871X)/HalEfuseMask8192E_SDIO.o
endif

ifeq ($(CONFIG_BT_COEXIST), y)
_BTC_FILES += hal/btc/halbtc8192e1ant.o \
				hal/btc/halbtc8192e2ant.o
endif

endif

########### HAL_RTL8812A_RTL8821A #################################

ifneq ($(CONFIG_RTL8812A)_$(CONFIG_RTL8821A), n_n)

RTL871X = rtl8812a
ifeq ($(CONFIG_USB_HCI), y)
MODULE_NAME = 8812au
endif
ifeq ($(CONFIG_PCI_HCI), y)
MODULE_NAME = 8812ae
endif
ifeq ($(CONFIG_SDIO_HCI), y)
MODULE_NAME = 8812as
endif

_HAL_INTFS_FILES +=  hal/HalPwrSeqCmd.o \
					hal/$(RTL871X)/Hal8812PwrSeq.o \
					hal/$(RTL871X)/Hal8821APwrSeq.o\
					hal/$(RTL871X)/$(RTL871X)_xmit.o\
					hal/$(RTL871X)/$(RTL871X)_sreset.o

_HAL_INTFS_FILES +=	hal/$(RTL871X)/$(RTL871X)_hal_init.o \
			hal/$(RTL871X)/$(RTL871X)_phycfg.o \
			hal/$(RTL871X)/$(RTL871X)_rf6052.o \
			hal/$(RTL871X)/$(RTL871X)_dm.o \
			hal/$(RTL871X)/$(RTL871X)_rxdesc.o \
			hal/$(RTL871X)/$(RTL871X)_cmd.o \
			hal/$(RTL871X)/$(HCI_NAME)/$(HCI_NAME)_halinit.o \
			hal/$(RTL871X)/$(HCI_NAME)/rtl$(MODULE_NAME)_led.o \
			hal/$(RTL871X)/$(HCI_NAME)/rtl$(MODULE_NAME)_xmit.o \
			hal/$(RTL871X)/$(HCI_NAME)/rtl$(MODULE_NAME)_recv.o

ifeq ($(CONFIG_SDIO_HCI), y)
_HAL_INTFS_FILES += hal/$(RTL871X)/$(HCI_NAME)/$(HCI_NAME)_ops.o
else
ifeq ($(CONFIG_GSPI_HCI), y)
_HAL_INTFS_FILES += hal/$(RTL871X)/$(HCI_NAME)/$(HCI_NAME)_ops.o
else
_HAL_INTFS_FILES += hal/$(RTL871X)/$(HCI_NAME)/$(HCI_NAME)_ops_linux.o
endif
endif

ifeq ($(CONFIG_RTL8812A), y)
ifeq ($(CONFIG_USB_HCI), y)
_HAL_INTFS_FILES +=hal/efuse/$(RTL871X)/HalEfuseMask8812A_USB.o
endif
ifeq ($(CONFIG_PCI_HCI), y)
_HAL_INTFS_FILES +=hal/efuse/$(RTL871X)/HalEfuseMask8812A_PCIE.o
endif
endif
ifeq ($(CONFIG_RTL8821A), y)
ifeq ($(CONFIG_USB_HCI), y)
_HAL_INTFS_FILES +=hal/efuse/$(RTL871X)/HalEfuseMask8821A_USB.o
endif
ifeq ($(CONFIG_PCI_HCI), y)
_HAL_INTFS_FILES +=hal/efuse/$(RTL871X)/HalEfuseMask8821A_PCIE.o
endif
ifeq ($(CONFIG_SDIO_HCI), y)
_HAL_INTFS_FILES +=hal/efuse/$(RTL871X)/HalEfuseMask8821A_SDIO.o
endif
endif

ifeq ($(CONFIG_RTL8812A), y)
EXTRA_CFLAGS += -DCONFIG_RTL8812A

=== debian/changelog ===
rtl8821ce (5.5.2.1-7~mx21+1) mx; urgency=medium

  * Rebuild for MX Linux.

 -- Steven Pusser <stevep@mxlinux.org>  Thu, 20 May 2021 15:01:41 -0700

rtl8821ce (5.5.2.1-0ubuntu7) impish; urgency=medium

  * Linux 5.12 support

 -- Paolo Pisati <paolo.pisati@canonical.com>  Wed, 05 May 2021 15:50:52 +0000

rtl8821ce (5.5.2.1-0ubuntu6) hirsute; urgency=medium

  * Blacklist built-in rtw88_8821ce (LP: #1911605)

  * Update CI release series

 -- You-Sheng Yang <vicamo.yang@canonical.com>  Fri, 22 Jan 2021 18:00:33 +0800

rtl8821ce (5.5.2.1-0ubuntu5) hirsute; urgency=medium

  * Convert readFile()/writeFile() to use kernel_read()/write_file() and fix
    FTBFS with Linux 5.10

 -- Paolo Pisati <paolo.pisati@canonical.com>  Fri, 04 Dec 2020 12:25:56 +0000

rtl8821ce (5.5.2.1-0ubuntu4) groovy; urgency=medium

  * Reconcile with debian/sid.
    - migrate to debhelper compatible level 12.
    - address lintian warnings
    - enable GitLab CI
    - enable autopkgtest

  * Fix build against v5.8 kernel (LP: #1884648)

  * Add missing supplier data rates (22, 33MB) (LP: #1865147)

 -- You-Sheng Yang <vicamo.yang@canonical.com>  Fri, 03 Jul 2020 15:43:11 +0800

rtl8821ce (5.5.2.1-0ubuntu3) focal; urgency=medium

  * debian/control:
    - build all architectures again.

  * debian/patches/*:
    - make: support build from multi-arched debian-based platform
    - rtl8821ce: use dma_addr_t
    - rtl8821ce: guard wireless_send_event with CONFIG_WIRELESS_EXT instead

 -- You-Sheng Yang <vicamo.yang@canonical.com>  Mon, 17 Feb 2020 21:04:38 +0800

rtl8821ce (5.5.2.1-0ubuntu2) focal; urgency=medium

  * debian/control:
    - build on amd64 only

 -- You-Sheng Yang <vicamo.yang@canonical.com>  Mon, 10 Feb 2020 16:04:34 +0800

rtl8821ce (5.5.2.1-0ubuntu1) focal; urgency=medium

  * New upstream release. (LP: #1861669)
    - rtl8821CE_WiFi_linux_v5.5.2_34066.20190614_COEX20180712-3232.tar.gz
    - rtl8821CE_WiFi_linux_v5.5.2.1_35598.20191029_COEX20180712-3232.tar.gz

  * rtl8821ce
    - respect some more environment vars
    - fix build against kernel >= v5.3
    - disable debug messages

  * debian/*:
    - update Vcs URLs
    - enable parallel build
    - fix DKMS builds
    - explicitely add missed build dependency: bc, quilt

 -- You-Sheng Yang <vicamo.yang@canonical.com>  Mon, 03 Feb 2020 17:45:11 +0800

=== debian/control ===
Source: rtl8821ce
Section: kernel
Priority: optional
Maintainer: Steven Pusser <stevep@mxlinux.org>
XSBC-Original-Maintainer: Canonical HWE Team <canonical-hwe@lists.canonical.com>
Rules-Requires-Root: no
Build-Depends: debhelper-compat (= 12), dh-modaliases, dkms, quilt
Standards-Version: 4.5.0
Homepage: https://launchpad.net/ubuntu/+source/rtl8821ce
Vcs-Git: https://git.launchpad.net/~canonical-hwe-team/ubuntu/+source/rtl8821ce-dkms/+git/rtl8821ce-dkms
Vcs-Browser: https://git.launchpad.net/~canonical-hwe-team/ubuntu/+source/rtl8821ce-dkms/+git/rtl8821ce-dkms

Package: rtl8821ce-dkms
Architecture: all
Depends: bc, dkms, ${misc:Depends}
XB-Modaliases: ${modaliases}
Description: DKMS source for the Realtek 8821C PCIe Wi-Fi driver
 Realtek provides the solution for WLAN in hardware and software. The software
 package could be adopted for Realtek RTL8821CE WLAN series hardware on Linux
 based platforms.
 .
 This package provides the DKMS source code for the rtl8821ce kernel module.
 Kernel source or headers are required to compile these modules.

=== debian/tests/control ===
Tests: dkms-autopkgtest
Restrictions:
 needs-root,
 allow-stderr,
Depends: gcc,
         linux-headers-686-pae | linux-headers-amd64 | linux-headers-generic | linux-headers

## rtl8821ce 5.5.2.1%2Bgit20221215

=== debian/changelog ===
rtl8821ce (5.5.2.1+git20221215-0.1~mx21+1) mx; urgency=medium

  * New pull from Github to support 6.1 kernels.
  * Don't use dh-modaliases or quilt for the build.

 -- Steven Pusser <stevep@mxlinux.org>  Tue, 17 Jan 2023 17:21:17 -0800

rtl8821ce (5.5.2.1+git20220911-0.1~mx21+1) mx; urgency=medium

  * New pull from Github to support 6.0 kernels.

 -- Steven Pusser <stevep@mxlinux.org>  Thu, 27 Oct 2022 13:58:07 -0700

rtl8821ce (5.5.2.1+git20220827-0.1~mx21+1) mx; urgency=medium

  * New pull from Github to support 5.19.2 or above kernels.
  * Disable patches.

 -- Steven Pusser <stevep@mxlinux.org>  Sat, 27 Aug 2022 12:45:22 -0700

rtl8821ce (5.5.2.1-11~mx21+1) mx; urgency=medium

  * Rebuild for MX Linux.

 -- Steven Pusser <stevep@mxlinux.org>  Mon, 08 Aug 2022 14:01:18 -0700

rtl8821ce (5.5.2.1-0ubuntu11) kinetic; urgency=medium

  * Linux 5.19 compatibility (LP: #1982080):
    - debian/patches/0020-support-linux-5.19.patch

 -- Andrea Righi <andrea.righi@canonical.com>  Tue, 19 Jul 2022 07:33:49 +0000

rtl8821ce (5.5.2.1-0ubuntu10) jammy; urgency=medium

  * Drop manual autopkgtest in favor of using the autodep8 one.

 -- Dimitri John Ledkov <dimitri.ledkov@canonical.com>  Mon, 11 Apr 2022 15:22:26 +0100

rtl8821ce (5.5.2.1-0ubuntu9) jammy; urgency=medium

  * Cherrypick Linux 5.17 support patch, and adjust dkms.conf to exclude
    building on wifi-less kernels. LP: #1968297

 -- Dimitri John Ledkov <dimitri.ledkov@canonical.com>  Fri, 08 Apr 2022 10:15:52 +0100

rtl8821ce (5.5.2.1-0ubuntu8) jammy; urgency=medium

  * Linux 5.15 support 

 -- Paolo Pisati <paolo.pisati@canonical.com>  Wed, 29 Sep 2021 08:53:52 +0000

=== debian/control ===
Source: rtl8821ce
Section: kernel
Priority: optional
Maintainer: Steven Pusser <stevep@mxlinux.org>
XSBC-Original-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
Rules-Requires-Root: no
Build-Depends: debhelper-compat (= 12),
               dkms
Standards-Version: 4.5.0
Homepage: https://github.com/tomaspinho/rtl8821ce

Package: rtl8821ce-dkms
Architecture: all
Depends: bc, dkms, ${misc:Depends}
#XB-Modaliases: ${modaliases}
Description: DKMS source for the Realtek 8821CE PCIe Wi-Fi driver
 Realtek provides the solution for WLAN in hardware and software. The software
 package could be adopted for Realtek RTL8821CE WLAN series hardware on Linux
 based platforms.
 .
 This package provides the DKMS source code for the rtl8821ce kernel module.
 Kernel source or headers are required to compile these modules. 
 .
 This update supports builds on kernel versions <= 6.1.

## rtl8821ce 5.5.2.1+git20220827

=== debian/control ===
Source: rtl8821ce
Section: kernel
Priority: optional
Maintainer: Steven Pusser <stevep@mxlinux.org>
XSBC-Original-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
# XSBC-Original-Maintainer: Canonical HWE Team <canonical-hwe@lists.canonical.com>
Rules-Requires-Root: no
Build-Depends: debhelper-compat (= 12), dh-modaliases, dkms, quilt
Standards-Version: 4.5.0
Homepage: https://github.com/tomaspinho/rtl8821ce

Package: rtl8821ce-dkms
Architecture: all
Depends: bc, dkms, ${misc:Depends}
XB-Modaliases: ${modaliases}
Description: DKMS source for the Realtek 8821C PCIe Wi-Fi driver
 Realtek provides the solution for WLAN in hardware and software. The software
 package could be adopted for Realtek RTL8821CE WLAN series hardware on Linux
 based platforms.
 .
 This package provides the DKMS source code for the rtl8821ce kernel module.
 Kernel source or headers are required to compile these modules.

## rtl8821ce 5.5.2.1+git20220911

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,6 @@
 Priority: optional
 Maintainer: Steven Pusser <stevep@mxlinux.org>
 XSBC-Original-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-# XSBC-Original-Maintainer: Canonical HWE Team <canonical-hwe@lists.canonical.com>
 Rules-Requires-Root: no
 Build-Depends: debhelper-compat (= 12), dh-modaliases, dkms, quilt
 Standards-Version: 4.5.0

## rtl8821ce 5.5.2.1+git20230504

=== Makefile ===
--- 
+++ 
@@ -7,6 +7,7 @@
 #EXTRA_CFLAGS += -pedantic
 #EXTRA_CFLAGS += -Wshadow -Wpointer-arith -Wcast-qual -Wstrict-prototypes -Wmissing-prototypes
 
+EXTRA_CFLAGS += -Wno-vla
 EXTRA_CFLAGS += -Wno-unused-variable
 EXTRA_CFLAGS += -Wno-unused-value
 EXTRA_CFLAGS += -Wno-unused-label
@@ -20,7 +21,15 @@
 EXTRA_CFLAGS += -Wno-date-time	# Fix compile error && warning on gcc 4.9 and later
 endif
 
-EXTRA_CFLAGS += -I$(src)/include
+ifeq (,$(srctree))
+    # make processing
+    export TopDIR ?= $(shell pwd)
+else
+    # dkms processing or in tree compilation
+    export TopDIR ?= $(srctree)/$(src)
+endif
+
+EXTRA_CFLAGS += -I$(TopDIR)/include
 
 EXTRA_LDFLAGS += --strip-debug
 
@@ -82,7 +91,7 @@
 CONFIG_RTW_WIFI_HAL = n
 CONFIG_ICMP_VOQ = n
 ########################## Debug ###########################
-CONFIG_RTW_DEBUG = y
+CONFIG_RTW_DEBUG = n
 # default log level is _DRV_INFO_ = 4,
 # please refer to "How_to_set_driver_debug_log_level.doc" to set the available level.
 CONFIG_RTW_LOG_LEVEL = 4
@@ -170,8 +179,6 @@
 
 CONFIG_DRVEXT_MODULE = n
 
-export TopDIR ?= $(shell pwd)
-
 ########### COMMON  #################################
 ifeq ($(CONFIG_GSPI_HCI), y)
 HCI_NAME = gspi
@@ -235,10 +242,10 @@
 			hal/led/hal_$(HCI_NAME)_led.o
 
 
-EXTRA_CFLAGS += -I$(src)/platform
+EXTRA_CFLAGS += -I$(TopDIR)/platform
 _PLATFORM_FILES := platform/platform_ops.o
 
-EXTRA_CFLAGS += -I$(src)/hal/btc
+EXTRA_CFLAGS += -I$(TopDIR)/hal/btc
 
 ########### HAL_RTL8188E #################################
 ifeq ($(CONFIG_RTL8188E), y)
@@ -263,7 +270,7 @@
 
 _HAL_INTFS_FILES +=	hal/HalPwrSeqCmd.o \
 					hal/$(RTL871X)/Hal8188EPwrSeq.o\
- 					hal/$(RTL871X)/$(RTL871X)_xmit.o\
+					hal/$(RTL871X)/$(RTL871X)_xmit.o\
 					hal/$(RTL871X)/$(RTL871X)_sreset.o
 
 _HAL_INTFS_FILES +=	hal/$(RTL871X)/$(RTL871X)_hal_init.o \
@@ -419,9 +426,3 @@
 _HAL_INTFS_FILES +=hal/efuse/$(RTL871X)/HalEfuseMask8821A_PCIE.o
 endif
 ifeq ($(CONFIG_SDIO_HCI), y)
-_HAL_INTFS_FILES +=hal/efuse/$(RTL871X)/HalEfuseMask8821A_SDIO.o
-endif
-endif
-
-ifeq ($(CONFIG_RTL8812A), y)
-EXTRA_CFLAGS += -DCONFIG_RTL8812A

=== debian/changelog ===
rtl8821ce (5.5.2.1+git20230504-0~mx23+1) mx; urgency=medium

  * Rebuild for MX-23

 -- Timothy E. Harris <maintainer@mxrepo.com>  Sat, 17 Jun 2023 19:41:55 -0400

rtl8821ce (5.5.2.1+git20230504-0~mx21+1) mx; urgency=medium

  * Support for kernel 6.3
  * Build for MX-21

 -- Timothy E. Harris <maintainer@mxrepo.com>  Sat, 17 Jun 2023 19:35:28 -0400

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk

%:
	dh $@ --with dkms

override_dh_install:
	dh_install -Xdebian \
	  -Xcore/mesh/rtw_mesh.o \
	  -Xcore/mesh/rtw_mesh_hwmp.o \
	  -Xcore/mesh/rtw_mesh_pathtbl.o \
	  * usr/src/rtl8821ce-$(DEB_VERSION_UPSTREAM)/

override_dh_dkms:
	dh_dkms -V $(DEB_VERSION_UPSTREAM)

override_dh_auto_configure:
override_dh_auto_build:
override_dh_auto_test:
override_dh_auto_install:
override_dh_auto_clean:

## rtl8821ce 5.5.2.1+git20240120

=== debian/changelog ===
rtl8821ce (5.5.2.1+git20240120-0~mx23) mx; urgency=medium

  * Support added for kernel 6.7

 -- Timothy E. Harris <maintainer@mxrepo.com>  Thu, 25 Jan 2024 11:53:02 -0500

## rtl8821ce 5.5.2.1+git20240526

=== debian/changelog ===
rtl8821ce (5.5.2.1+git20240526-0~mx23) mx; urgency=medium

  * Suppoert added for kernel 6.9

 -- Timothy E. Harris <maintainer@mxrepo.com>  Thu, 05 Jun 2024 22:28:42 -0400

## rtl8821ce 5.5.2.1+git20250208

=== debian/changelog ===
rtl8821ce (5.5.2.1+git20250208-0~mx21) mx; urgency=medium

  * Rebuild for MX-21

 -- Timothy E. Harris <maintainer@mxrepo.com>  Wed, 05 Mar 2025 20:02:39 +0000

rtl8821ce (5.5.2.1+git20250208-0~mx23) mx; urgency=medium

  * Added support for kernel 6.13

 -- Timothy E. Harris <maintainer@mxrepo.com>  Wed, 05 Mar 2025 20:00:02 +0000

=== debian/control ===
Source: rtl8821ce
Section: kernel
Priority: optional
Maintainer: Steven Pusser <stevep@mxlinux.org>
XSBC-Original-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
Rules-Requires-Root: no
Build-Depends: debhelper-compat (= 12),
               dkms,
               dh-dkms
Standards-Version: 4.5.0
Homepage: https://github.com/tomaspinho/rtl8821ce

Package: rtl8821ce-dkms
Architecture: all
Depends: bc, dkms, ${misc:Depends}
#XB-Modaliases: ${modaliases}
Description: DKMS source for the Realtek 8821CE PCIe Wi-Fi driver
 Realtek provides the solution for WLAN in hardware and software. The software
 package could be adopted for Realtek RTL8821CE WLAN series hardware on Linux
 based platforms.
 .
 This package provides the DKMS source code for the rtl8821ce kernel module.
 Kernel source or headers are required to compile these modules. 
 .
 This update supports builds on kernel versions <= 6.1.
